package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.CorridaInfoDAO;
import com.rjconsultores.ventaboletos.entidad.Corrida;
import com.rjconsultores.ventaboletos.entidad.CorridaInfo;
import com.rjconsultores.ventaboletos.service.CorridaInfoService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

@Service("corridaInfoService")
public class CorridaInfoServiceImpl implements CorridaInfoService {

	@Autowired
	private CorridaInfoDAO corridaInfoDAO;

	@Override
	public List<CorridaInfo> obtenerTodos() {
		return corridaInfoDAO.obtenerTodos();
	}

	@Override
	public CorridaInfo obtenerID(Integer id) {
		return corridaInfoDAO.obtenerID(id);
	}

	@Transactional
	@Override
	public  CorridaInfo suscribir( CorridaInfo entidad) {
		
		if (UsuarioLogado.getUsuarioLogado() != null) {
			entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        } else {
        	entidad.setUsuarioId(1);
        }
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);
	
		return corridaInfoDAO.suscribir(entidad);
	}

	@Transactional
	@Override
	public CorridaInfo actualizacion(CorridaInfo entidad) {
		
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.TRUE);
		return corridaInfoDAO.actualizacion(entidad);
	}

	@Transactional
	@Override
	public void borrar(CorridaInfo entidad) {
		
		entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
		entidad.setFecmodif(Calendar.getInstance().getTime());
		entidad.setActivo(Boolean.FALSE);
		corridaInfoDAO.actualizacion(entidad);
	}

	@Transactional

	@Override
	public void borrarByCorrida(Corrida corrida) {
		 corridaInfoDAO.borrarByCorrida(corrida);		
	}

}
